org.codehaus.groovy.antlr.treewalker

## Class SourcePrinter

- java.lang.Object
- - org.codehaus.groovy.antlr.treewalker.VisitorAdapter
  - - org.codehaus.groovy.antlr.treewalker.SourcePrinter

All Implemented Interfaces:
  Visitor

    public class SourcePrinter
    extends VisitorAdapter

An antlr AST visitor that prints groovy source code for each visited node to the supplied PrintStream.

Author:
  Jeremy Rayner

### Field Summary

Fields
`protected java.io.PrintStream` `out`

### Fields inherited from interface org.codehaus.groovy.antlr.treewalker.Visitor

`CLOSING_VISIT, OPENING_VISIT, SECOND_VISIT, SUBSEQUENT_VISIT`

### Constructor Summary

Constructors
Constructor and Description
`SourcePrinter(java.io.PrintStream out, java.lang.String[] tokenNames)` A visitor that prints groovy source code for each node visited.
`SourcePrinter(java.io.PrintStream out, java.lang.String[] tokenNames, boolean newLines)` A visitor that prints groovy source code for each node visited.

### Method Summary

All Methods Instance Methods Concrete Methods
`GroovySourceAST` `pop()`
`protected void` `print(GroovySourceAST t, int visit, java.lang.String value)`
`protected void` `print(GroovySourceAST t, int visit, java.lang.String opening, java.lang.String subsequent, java.lang.String closing)`
`protected void` `printNewlineAndIndent(GroovySourceAST t, int visit)`
`protected void` `printUpdatingTabLevel(GroovySourceAST t, int visit, java.lang.String opening, java.lang.String subsequent, java.lang.String closing)`
`void` `push(GroovySourceAST t)`
`void` `visitAbstract(GroovySourceAST t, int visit)`
`void` `visitAnnotation(GroovySourceAST t, int visit)`
`void` `visitAnnotationDef(GroovySourceAST t, int visit)`
`void` `visitAnnotationFieldDef(GroovySourceAST t, int visit)`
`void` `visitAnnotationMemberValuePair(GroovySourceAST t, int visit)`
`void` `visitAnnotations(GroovySourceAST t, int visit)`
`void` `visitArrayDeclarator(GroovySourceAST t, int visit)`
`void` `visitAssign(GroovySourceAST t, int visit)`
`void` `visitBand(GroovySourceAST t, int visit)`
`void` `visitBandAssign(GroovySourceAST t, int visit)`
`void` `visitBnot(GroovySourceAST t, int visit)`
`void` `visitBor(GroovySourceAST t, int visit)`
`void` `visitBorAssign(GroovySourceAST t, int visit)`
`void` `visitBsr(GroovySourceAST t, int visit)`
`void` `visitBsrAssign(GroovySourceAST t, int visit)`
`void` `visitBxor(GroovySourceAST t, int visit)`
`void` `visitBxorAssign(GroovySourceAST t, int visit)`
`void` `visitCaseGroup(GroovySourceAST t, int visit)`
`void` `visitClassDef(GroovySourceAST t, int visit)`
`void` `visitClosedBlock(GroovySourceAST t, int visit)`
`void` `visitClosureList(GroovySourceAST t, int visit)`
`void` `visitCompareTo(GroovySourceAST t, int visit)`
`void` `visitCtorCall(GroovySourceAST t, int visit)`
`void` `visitCtorIdent(GroovySourceAST t, int visit)`
`void` `visitDec(GroovySourceAST t, int visit)`
`void` `visitDefault(GroovySourceAST t, int visit)`
`void` `visitDiv(GroovySourceAST t, int visit)`
`void` `visitDivAssign(GroovySourceAST t, int visit)`
`void` `visitDot(GroovySourceAST t, int visit)`
`void` `visitDynamicMember(GroovySourceAST t, int visit)`
`void` `visitElist(GroovySourceAST t, int visit)`
`void` `visitEnumConstantDef(GroovySourceAST t, int visit)`
`void` `visitEnumDef(GroovySourceAST t, int visit)`
`void` `visitEqual(GroovySourceAST t, int visit)`
`void` `visitExpr(GroovySourceAST t, int visit)`
`void` `visitExtendsClause(GroovySourceAST t, int visit)`
`void` `visitFinal(GroovySourceAST t, int visit)`
`void` `visitForCondition(GroovySourceAST t, int visit)`
`void` `visitForInit(GroovySourceAST t, int visit)`
`void` `visitForInIterable(GroovySourceAST t, int visit)`
`void` `visitForIterator(GroovySourceAST t, int visit)`
`void` `visitGe(GroovySourceAST t, int visit)`
`void` `visitGt(GroovySourceAST t, int visit)`
`void` `visitIdent(GroovySourceAST t, int visit)`
`void` `visitImplementsClause(GroovySourceAST t, int visit)`
`void` `visitImplicitParameters(GroovySourceAST t, int visit)`
`void` `visitImport(GroovySourceAST t, int visit)`
`void` `visitInc(GroovySourceAST t, int visit)`
`void` `visitIndexOp(GroovySourceAST t, int visit)`
`void` `visitInstanceInit(GroovySourceAST t, int visit)`
`void` `visitInterfaceDef(GroovySourceAST t, int visit)`
`void` `visitLabeledArg(GroovySourceAST t, int visit)`
`void` `visitLabeledStat(GroovySourceAST t, int visit)`
`void` `visitLand(GroovySourceAST t, int visit)`
`void` `visitLe(GroovySourceAST t, int visit)`
`void` `visitListConstructor(GroovySourceAST t, int visit)`
`void` `visitLiteralAs(GroovySourceAST t, int visit)`
`void` `visitLiteralAssert(GroovySourceAST t, int visit)`
`void` `visitLiteralBoolean(GroovySourceAST t, int visit)`
`void` `visitLiteralBreak(GroovySourceAST t, int visit)`
`void` `visitLiteralByte(GroovySourceAST t, int visit)`
`void` `visitLiteralCase(GroovySourceAST t, int visit)`
`void` `visitLiteralCatch(GroovySourceAST t, int visit)`
`void` `visitLiteralChar(GroovySourceAST t, int visit)`
`void` `visitLiteralContinue(GroovySourceAST t, int visit)`
`void` `visitLiteralDefault(GroovySourceAST t, int visit)`
`void` `visitLiteralDouble(GroovySourceAST t, int visit)`
`void` `visitLiteralFalse(GroovySourceAST t, int visit)`
`void` `visitLiteralFinally(GroovySourceAST t, int visit)`
`void` `visitLiteralFloat(GroovySourceAST t, int visit)`
`void` `visitLiteralFor(GroovySourceAST t, int visit)`
`void` `visitLiteralIf(GroovySourceAST t, int visit)`
`void` `visitLiteralIn(GroovySourceAST t, int visit)`
`void` `visitLiteralInstanceof(GroovySourceAST t, int visit)`
`void` `visitLiteralInt(GroovySourceAST t, int visit)`
`void` `visitLiteralLong(GroovySourceAST t, int visit)`
`void` `visitLiteralNative(GroovySourceAST t, int visit)`
`void` `visitLiteralNew(GroovySourceAST t, int visit)`
`void` `visitLiteralNull(GroovySourceAST t, int visit)`
`void` `visitLiteralPrivate(GroovySourceAST t, int visit)`
`void` `visitLiteralProtected(GroovySourceAST t, int visit)`
`void` `visitLiteralPublic(GroovySourceAST t, int visit)`
`void` `visitLiteralReturn(GroovySourceAST t, int visit)`
`void` `visitLiteralShort(GroovySourceAST t, int visit)`
`void` `visitLiteralStatic(GroovySourceAST t, int visit)`
`void` `visitLiteralSuper(GroovySourceAST t, int visit)`
`void` `visitLiteralSwitch(GroovySourceAST t, int visit)`
`void` `visitLiteralSynchronized(GroovySourceAST t, int visit)`
`void` `visitLiteralThis(GroovySourceAST t, int visit)`
`void` `visitLiteralThreadsafe(GroovySourceAST t, int visit)`
`void` `visitLiteralThrow(GroovySourceAST t, int visit)`
`void` `visitLiteralThrows(GroovySourceAST t, int visit)`
`void` `visitLiteralTransient(GroovySourceAST t, int visit)`
`void` `visitLiteralTrue(GroovySourceAST t, int visit)`
`void` `visitLiteralTry(GroovySourceAST t, int visit)`
`void` `visitLiteralVoid(GroovySourceAST t, int visit)`
`void` `visitLiteralVolatile(GroovySourceAST t, int visit)`
`void` `visitLiteralWhile(GroovySourceAST t, int visit)`
`void` `visitLnot(GroovySourceAST t, int visit)`
`void` `visitLor(GroovySourceAST t, int visit)`
`void` `visitLt(GroovySourceAST t, int visit)`
`void` `visitMapConstructor(GroovySourceAST t, int visit)`
`void` `visitMemberPointer(GroovySourceAST t, int visit)`
`void` `visitMethodCall(GroovySourceAST t, int visit)`
`void` `visitMethodDef(GroovySourceAST t, int visit)`
`void` `visitMinus(GroovySourceAST t, int visit)`
`void` `visitMinusAssign(GroovySourceAST t, int visit)`
`void` `visitMod(GroovySourceAST t, int visit)`
`void` `visitModAssign(GroovySourceAST t, int visit)`
`void` `visitModifiers(GroovySourceAST t, int visit)`
`void` `visitMultiCatch(GroovySourceAST t, int visit)`
`void` `visitMultiCatchTypes(GroovySourceAST t, int visit)`
`void` `visitNotEqual(GroovySourceAST t, int visit)`
`void` `visitNumBigDecimal(GroovySourceAST t, int visit)`
`void` `visitNumBigInt(GroovySourceAST t, int visit)`
`void` `visitNumDouble(GroovySourceAST t, int visit)`
`void` `visitNumFloat(GroovySourceAST t, int visit)`
`void` `visitNumInt(GroovySourceAST t, int visit)`
`void` `visitNumLong(GroovySourceAST t, int visit)`
`void` `visitObjblock(GroovySourceAST t, int visit)`
`void` `visitOptionalDot(GroovySourceAST t, int visit)`
`void` `visitPackageDef(GroovySourceAST t, int visit)`
`void` `visitParameterDef(GroovySourceAST t, int visit)`
`void` `visitParameters(GroovySourceAST t, int visit)`
`void` `visitPlus(GroovySourceAST t, int visit)`
`void` `visitPlusAssign(GroovySourceAST t, int visit)`
`void` `visitPostDec(GroovySourceAST t, int visit)`
`void` `visitPostInc(GroovySourceAST t, int visit)`
`void` `visitQuestion(GroovySourceAST t, int visit)`
`void` `visitRangeExclusive(GroovySourceAST t, int visit)`
`void` `visitRangeInclusive(GroovySourceAST t, int visit)`
`void` `visitRegexFind(GroovySourceAST t, int visit)`
`void` `visitRegexMatch(GroovySourceAST t, int visit)`
`void` `visitSelectSlot(GroovySourceAST t, int visit)`
`void` `visitSl(GroovySourceAST t, int visit)`
`void` `visitSlAssign(GroovySourceAST t, int visit)`
`void` `visitSlist(GroovySourceAST t, int visit)`
`void` `visitSpreadArg(GroovySourceAST t, int visit)`
`void` `visitSpreadDot(GroovySourceAST t, int visit)`
`void` `visitSpreadMapArg(GroovySourceAST t, int visit)`
`void` `visitSr(GroovySourceAST t, int visit)`
`void` `visitSrAssign(GroovySourceAST t, int visit)`
`void` `visitStar(GroovySourceAST t, int visit)`
`void` `visitStarAssign(GroovySourceAST t, int visit)`
`void` `visitStarStar(GroovySourceAST t, int visit)`
`void` `visitStarStarAssign(GroovySourceAST t, int visit)`
`void` `visitStaticImport(GroovySourceAST t, int visit)`
`void` `visitStaticInit(GroovySourceAST t, int visit)`
`void` `visitStrictfp(GroovySourceAST t, int visit)`
`void` `visitStringConstructor(GroovySourceAST t, int visit)`
`void` `visitStringLiteral(GroovySourceAST t, int visit)`
`void` `visitSuperCtorCall(GroovySourceAST t, int visit)`
`void` `visitTraitDef(GroovySourceAST t, int visit)`
`void` `visitType(GroovySourceAST t, int visit)`
`void` `visitTypeArgument(GroovySourceAST t, int visit)`
`void` `visitTypeArguments(GroovySourceAST t, int visit)`
`void` `visitTypecast(GroovySourceAST t, int visit)`
`void` `visitTypeLowerBounds(GroovySourceAST t, int visit)`
`void` `visitTypeParameter(GroovySourceAST t, int visit)`
`void` `visitTypeParameters(GroovySourceAST t, int visit)`
`void` `visitTypeUpperBounds(GroovySourceAST t, int visit)`
`void` `visitUnaryMinus(GroovySourceAST t, int visit)`
`void` `visitUnaryPlus(GroovySourceAST t, int visit)`
`void` `visitVariableDef(GroovySourceAST t, int visit)`
`void` `visitVariableParameterDef(GroovySourceAST t, int visit)`
`void` `visitWildcardType(GroovySourceAST t, int visit)`

### Methods inherited from class org.codehaus.groovy.antlr.treewalker.VisitorAdapter

`setUp, tearDown, visitAnnotationArrayInit, visitAt, visitBigSuffix, visitBlock, visitClosureOp, visitColon, visitComma, visitDigit, visitDollar, visitEmptyStat, visitEof, visitEsc, visitExponent, visitFloatSuffix, visitForEachClause, visitHexDigit, visitLbrack, visitLcurly, visitLetter, visitLiteralClass, visitLiteralDef, visitLiteralElse, visitLiteralEnum, visitLiteralExtends, visitLiteralImplements, visitLiteralImport, visitLiteralInterface, visitLiteralPackage, visitLparen, visitMlComment, visitNls, visitNullTreeLookahead, visitOneNl, visitRbrack, visitRcurly, visitRegexpCtorEnd, visitRegexpLiteral, visitRegexpSymbol, visitRparen, visitSemi, visitShComment, visitSlComment, visitStringCh, visitStringCtorEnd, visitStringCtorMiddle, visitStringCtorStart, visitStringNl, visitTripleDot, visitUnusedConst, visitUnusedDo, visitUnusedGoto, visitVocab, visitWs`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### out

    protected final java.io.PrintStream out

### Constructor Detail

#### SourcePrinter

    public SourcePrinter(java.io.PrintStream out,
                         java.lang.String[] tokenNames)

A visitor that prints groovy source code for each node visited.

Parameters:
  `out` - where to print the source code to
  `tokenNames` - an array of token names from antlr

#### SourcePrinter

    public SourcePrinter(java.io.PrintStream out,
                         java.lang.String[] tokenNames,
                         boolean newLines)

A visitor that prints groovy source code for each node visited.

Parameters:
  `out` - where to print the source code to
  `tokenNames` - an array of token names from antlr
  `newLines` - output newline character

### Method Detail

#### visitAbstract

    public void visitAbstract(GroovySourceAST t,
                              int visit)

Specified by:
  `visitAbstract` in interface `Visitor`
Overrides:
  `visitAbstract` in class `VisitorAdapter`

#### visitAnnotation

    public void visitAnnotation(GroovySourceAST t,
                                int visit)

Specified by:
  `visitAnnotation` in interface `Visitor`
Overrides:
  `visitAnnotation` in class `VisitorAdapter`

#### visitAnnotations

    public void visitAnnotations(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitAnnotations` in interface `Visitor`
Overrides:
  `visitAnnotations` in class `VisitorAdapter`

#### visitAnnotationDef

    public void visitAnnotationDef(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitAnnotationDef` in interface `Visitor`
Overrides:
  `visitAnnotationDef` in class `VisitorAdapter`

#### visitAnnotationFieldDef

    public void visitAnnotationFieldDef(GroovySourceAST t,
                                        int visit)

Specified by:
  `visitAnnotationFieldDef` in interface `Visitor`
Overrides:
  `visitAnnotationFieldDef` in class `VisitorAdapter`

#### visitAnnotationMemberValuePair

    public void visitAnnotationMemberValuePair(GroovySourceAST t,
                                               int visit)

Specified by:
  `visitAnnotationMemberValuePair` in interface `Visitor`
Overrides:
  `visitAnnotationMemberValuePair` in class `VisitorAdapter`

#### visitArrayDeclarator

    public void visitArrayDeclarator(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitArrayDeclarator` in interface `Visitor`
Overrides:
  `visitArrayDeclarator` in class `VisitorAdapter`

#### visitAssign

    public void visitAssign(GroovySourceAST t,
                            int visit)

Specified by:
  `visitAssign` in interface `Visitor`
Overrides:
  `visitAssign` in class `VisitorAdapter`

#### visitBand

    public void visitBand(GroovySourceAST t,
                          int visit)

Specified by:
  `visitBand` in interface `Visitor`
Overrides:
  `visitBand` in class `VisitorAdapter`

#### visitBandAssign

    public void visitBandAssign(GroovySourceAST t,
                                int visit)

Specified by:
  `visitBandAssign` in interface `Visitor`
Overrides:
  `visitBandAssign` in class `VisitorAdapter`

#### visitBnot

    public void visitBnot(GroovySourceAST t,
                          int visit)

Specified by:
  `visitBnot` in interface `Visitor`
Overrides:
  `visitBnot` in class `VisitorAdapter`

#### visitBor

    public void visitBor(GroovySourceAST t,
                         int visit)

Specified by:
  `visitBor` in interface `Visitor`
Overrides:
  `visitBor` in class `VisitorAdapter`

#### visitBorAssign

    public void visitBorAssign(GroovySourceAST t,
                               int visit)

Specified by:
  `visitBorAssign` in interface `Visitor`
Overrides:
  `visitBorAssign` in class `VisitorAdapter`

#### visitBsr

    public void visitBsr(GroovySourceAST t,
                         int visit)

Specified by:
  `visitBsr` in interface `Visitor`
Overrides:
  `visitBsr` in class `VisitorAdapter`

#### visitBsrAssign

    public void visitBsrAssign(GroovySourceAST t,
                               int visit)

Specified by:
  `visitBsrAssign` in interface `Visitor`
Overrides:
  `visitBsrAssign` in class `VisitorAdapter`

#### visitBxor

    public void visitBxor(GroovySourceAST t,
                          int visit)

Specified by:
  `visitBxor` in interface `Visitor`
Overrides:
  `visitBxor` in class `VisitorAdapter`

#### visitBxorAssign

    public void visitBxorAssign(GroovySourceAST t,
                                int visit)

Specified by:
  `visitBxorAssign` in interface `Visitor`
Overrides:
  `visitBxorAssign` in class `VisitorAdapter`

#### visitCaseGroup

    public void visitCaseGroup(GroovySourceAST t,
                               int visit)

Specified by:
  `visitCaseGroup` in interface `Visitor`
Overrides:
  `visitCaseGroup` in class `VisitorAdapter`

#### visitClassDef

    public void visitClassDef(GroovySourceAST t,
                              int visit)

Specified by:
  `visitClassDef` in interface `Visitor`
Overrides:
  `visitClassDef` in class `VisitorAdapter`

#### visitClosedBlock

    public void visitClosedBlock(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitClosedBlock` in interface `Visitor`
Overrides:
  `visitClosedBlock` in class `VisitorAdapter`

#### visitClosureList

    public void visitClosureList(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitClosureList` in interface `Visitor`
Overrides:
  `visitClosureList` in class `VisitorAdapter`

#### visitCompareTo

    public void visitCompareTo(GroovySourceAST t,
                               int visit)

Specified by:
  `visitCompareTo` in interface `Visitor`
Overrides:
  `visitCompareTo` in class `VisitorAdapter`

#### visitCtorCall

    public void visitCtorCall(GroovySourceAST t,
                              int visit)

Specified by:
  `visitCtorCall` in interface `Visitor`
Overrides:
  `visitCtorCall` in class `VisitorAdapter`

#### visitCtorIdent

    public void visitCtorIdent(GroovySourceAST t,
                               int visit)

Specified by:
  `visitCtorIdent` in interface `Visitor`
Overrides:
  `visitCtorIdent` in class `VisitorAdapter`

#### visitDec

    public void visitDec(GroovySourceAST t,
                         int visit)

Specified by:
  `visitDec` in interface `Visitor`
Overrides:
  `visitDec` in class `VisitorAdapter`

#### visitDiv

    public void visitDiv(GroovySourceAST t,
                         int visit)

Specified by:
  `visitDiv` in interface `Visitor`
Overrides:
  `visitDiv` in class `VisitorAdapter`

#### visitDivAssign

    public void visitDivAssign(GroovySourceAST t,
                               int visit)

Specified by:
  `visitDivAssign` in interface `Visitor`
Overrides:
  `visitDivAssign` in class `VisitorAdapter`

#### visitDot

    public void visitDot(GroovySourceAST t,
                         int visit)

Specified by:
  `visitDot` in interface `Visitor`
Overrides:
  `visitDot` in class `VisitorAdapter`

#### visitDynamicMember

    public void visitDynamicMember(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitDynamicMember` in interface `Visitor`
Overrides:
  `visitDynamicMember` in class `VisitorAdapter`

#### visitElist

    public void visitElist(GroovySourceAST t,
                           int visit)

Specified by:
  `visitElist` in interface `Visitor`
Overrides:
  `visitElist` in class `VisitorAdapter`

#### visitEnumConstantDef

    public void visitEnumConstantDef(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitEnumConstantDef` in interface `Visitor`
Overrides:
  `visitEnumConstantDef` in class `VisitorAdapter`

#### visitEnumDef

    public void visitEnumDef(GroovySourceAST t,
                             int visit)

Specified by:
  `visitEnumDef` in interface `Visitor`
Overrides:
  `visitEnumDef` in class `VisitorAdapter`

#### visitEqual

    public void visitEqual(GroovySourceAST t,
                           int visit)

Specified by:
  `visitEqual` in interface `Visitor`
Overrides:
  `visitEqual` in class `VisitorAdapter`

#### visitExpr

    public void visitExpr(GroovySourceAST t,
                          int visit)

Specified by:
  `visitExpr` in interface `Visitor`
Overrides:
  `visitExpr` in class `VisitorAdapter`

#### visitExtendsClause

    public void visitExtendsClause(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitExtendsClause` in interface `Visitor`
Overrides:
  `visitExtendsClause` in class `VisitorAdapter`

#### visitFinal

    public void visitFinal(GroovySourceAST t,
                           int visit)

Specified by:
  `visitFinal` in interface `Visitor`
Overrides:
  `visitFinal` in class `VisitorAdapter`

#### visitForCondition

    public void visitForCondition(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitForCondition` in interface `Visitor`
Overrides:
  `visitForCondition` in class `VisitorAdapter`

#### visitForInit

    public void visitForInit(GroovySourceAST t,
                             int visit)

Specified by:
  `visitForInit` in interface `Visitor`
Overrides:
  `visitForInit` in class `VisitorAdapter`

#### visitForInIterable

    public void visitForInIterable(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitForInIterable` in interface `Visitor`
Overrides:
  `visitForInIterable` in class `VisitorAdapter`

#### visitForIterator

    public void visitForIterator(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitForIterator` in interface `Visitor`
Overrides:
  `visitForIterator` in class `VisitorAdapter`

#### visitGe

    public void visitGe(GroovySourceAST t,
                        int visit)

Specified by:
  `visitGe` in interface `Visitor`
Overrides:
  `visitGe` in class `VisitorAdapter`

#### visitGt

    public void visitGt(GroovySourceAST t,
                        int visit)

Specified by:
  `visitGt` in interface `Visitor`
Overrides:
  `visitGt` in class `VisitorAdapter`

#### visitIdent

    public void visitIdent(GroovySourceAST t,
                           int visit)

Specified by:
  `visitIdent` in interface `Visitor`
Overrides:
  `visitIdent` in class `VisitorAdapter`

#### visitImplementsClause

    public void visitImplementsClause(GroovySourceAST t,
                                      int visit)

Specified by:
  `visitImplementsClause` in interface `Visitor`
Overrides:
  `visitImplementsClause` in class `VisitorAdapter`

#### visitImplicitParameters

    public void visitImplicitParameters(GroovySourceAST t,
                                        int visit)

Specified by:
  `visitImplicitParameters` in interface `Visitor`
Overrides:
  `visitImplicitParameters` in class `VisitorAdapter`

#### visitImport

    public void visitImport(GroovySourceAST t,
                            int visit)

Specified by:
  `visitImport` in interface `Visitor`
Overrides:
  `visitImport` in class `VisitorAdapter`

#### visitInc

    public void visitInc(GroovySourceAST t,
                         int visit)

Specified by:
  `visitInc` in interface `Visitor`
Overrides:
  `visitInc` in class `VisitorAdapter`

#### visitIndexOp

    public void visitIndexOp(GroovySourceAST t,
                             int visit)

Specified by:
  `visitIndexOp` in interface `Visitor`
Overrides:
  `visitIndexOp` in class `VisitorAdapter`

#### visitInterfaceDef

    public void visitInterfaceDef(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitInterfaceDef` in interface `Visitor`
Overrides:
  `visitInterfaceDef` in class `VisitorAdapter`

#### visitInstanceInit

    public void visitInstanceInit(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitInstanceInit` in interface `Visitor`
Overrides:
  `visitInstanceInit` in class `VisitorAdapter`

#### visitLabeledArg

    public void visitLabeledArg(GroovySourceAST t,
                                int visit)

Specified by:
  `visitLabeledArg` in interface `Visitor`
Overrides:
  `visitLabeledArg` in class `VisitorAdapter`

#### visitLabeledStat

    public void visitLabeledStat(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLabeledStat` in interface `Visitor`
Overrides:
  `visitLabeledStat` in class `VisitorAdapter`

#### visitLand

    public void visitLand(GroovySourceAST t,
                          int visit)

Specified by:
  `visitLand` in interface `Visitor`
Overrides:
  `visitLand` in class `VisitorAdapter`

#### visitLe

    public void visitLe(GroovySourceAST t,
                        int visit)

Specified by:
  `visitLe` in interface `Visitor`
Overrides:
  `visitLe` in class `VisitorAdapter`

#### visitListConstructor

    public void visitListConstructor(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitListConstructor` in interface `Visitor`
Overrides:
  `visitListConstructor` in class `VisitorAdapter`

#### visitLiteralAs

    public void visitLiteralAs(GroovySourceAST t,
                               int visit)

Specified by:
  `visitLiteralAs` in interface `Visitor`
Overrides:
  `visitLiteralAs` in class `VisitorAdapter`

#### visitLiteralAssert

    public void visitLiteralAssert(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralAssert` in interface `Visitor`
Overrides:
  `visitLiteralAssert` in class `VisitorAdapter`

#### visitLiteralBoolean

    public void visitLiteralBoolean(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitLiteralBoolean` in interface `Visitor`
Overrides:
  `visitLiteralBoolean` in class `VisitorAdapter`

#### visitLiteralBreak

    public void visitLiteralBreak(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralBreak` in interface `Visitor`
Overrides:
  `visitLiteralBreak` in class `VisitorAdapter`

#### visitLiteralByte

    public void visitLiteralByte(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralByte` in interface `Visitor`
Overrides:
  `visitLiteralByte` in class `VisitorAdapter`

#### visitLiteralCase

    public void visitLiteralCase(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralCase` in interface `Visitor`
Overrides:
  `visitLiteralCase` in class `VisitorAdapter`

#### visitLiteralCatch

    public void visitLiteralCatch(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralCatch` in interface `Visitor`
Overrides:
  `visitLiteralCatch` in class `VisitorAdapter`

#### visitLiteralChar

    public void visitLiteralChar(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralChar` in interface `Visitor`
Overrides:
  `visitLiteralChar` in class `VisitorAdapter`

#### visitLiteralContinue

    public void visitLiteralContinue(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitLiteralContinue` in interface `Visitor`
Overrides:
  `visitLiteralContinue` in class `VisitorAdapter`

#### visitLiteralDefault

    public void visitLiteralDefault(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitLiteralDefault` in interface `Visitor`
Overrides:
  `visitLiteralDefault` in class `VisitorAdapter`

#### visitLiteralDouble

    public void visitLiteralDouble(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralDouble` in interface `Visitor`
Overrides:
  `visitLiteralDouble` in class `VisitorAdapter`

#### visitLiteralFalse

    public void visitLiteralFalse(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralFalse` in interface `Visitor`
Overrides:
  `visitLiteralFalse` in class `VisitorAdapter`

#### visitLiteralFinally

    public void visitLiteralFinally(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitLiteralFinally` in interface `Visitor`
Overrides:
  `visitLiteralFinally` in class `VisitorAdapter`

#### visitLiteralFloat

    public void visitLiteralFloat(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralFloat` in interface `Visitor`
Overrides:
  `visitLiteralFloat` in class `VisitorAdapter`

#### visitLiteralFor

    public void visitLiteralFor(GroovySourceAST t,
                                int visit)

Specified by:
  `visitLiteralFor` in interface `Visitor`
Overrides:
  `visitLiteralFor` in class `VisitorAdapter`

#### visitLiteralIf

    public void visitLiteralIf(GroovySourceAST t,
                               int visit)

Specified by:
  `visitLiteralIf` in interface `Visitor`
Overrides:
  `visitLiteralIf` in class `VisitorAdapter`

#### visitLiteralIn

    public void visitLiteralIn(GroovySourceAST t,
                               int visit)

Specified by:
  `visitLiteralIn` in interface `Visitor`
Overrides:
  `visitLiteralIn` in class `VisitorAdapter`

#### visitLiteralInstanceof

    public void visitLiteralInstanceof(GroovySourceAST t,
                                       int visit)

Specified by:
  `visitLiteralInstanceof` in interface `Visitor`
Overrides:
  `visitLiteralInstanceof` in class `VisitorAdapter`

#### visitLiteralInt

    public void visitLiteralInt(GroovySourceAST t,
                                int visit)

Specified by:
  `visitLiteralInt` in interface `Visitor`
Overrides:
  `visitLiteralInt` in class `VisitorAdapter`

#### visitLiteralLong

    public void visitLiteralLong(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralLong` in interface `Visitor`
Overrides:
  `visitLiteralLong` in class `VisitorAdapter`

#### visitLiteralNative

    public void visitLiteralNative(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralNative` in interface `Visitor`
Overrides:
  `visitLiteralNative` in class `VisitorAdapter`

#### visitLiteralNew

    public void visitLiteralNew(GroovySourceAST t,
                                int visit)

Specified by:
  `visitLiteralNew` in interface `Visitor`
Overrides:
  `visitLiteralNew` in class `VisitorAdapter`

#### visitLiteralNull

    public void visitLiteralNull(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralNull` in interface `Visitor`
Overrides:
  `visitLiteralNull` in class `VisitorAdapter`

#### visitLiteralPrivate

    public void visitLiteralPrivate(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitLiteralPrivate` in interface `Visitor`
Overrides:
  `visitLiteralPrivate` in class `VisitorAdapter`

#### visitLiteralProtected

    public void visitLiteralProtected(GroovySourceAST t,
                                      int visit)

Specified by:
  `visitLiteralProtected` in interface `Visitor`
Overrides:
  `visitLiteralProtected` in class `VisitorAdapter`

#### visitLiteralPublic

    public void visitLiteralPublic(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralPublic` in interface `Visitor`
Overrides:
  `visitLiteralPublic` in class `VisitorAdapter`

#### visitLiteralReturn

    public void visitLiteralReturn(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralReturn` in interface `Visitor`
Overrides:
  `visitLiteralReturn` in class `VisitorAdapter`

#### visitLiteralShort

    public void visitLiteralShort(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralShort` in interface `Visitor`
Overrides:
  `visitLiteralShort` in class `VisitorAdapter`

#### visitLiteralStatic

    public void visitLiteralStatic(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralStatic` in interface `Visitor`
Overrides:
  `visitLiteralStatic` in class `VisitorAdapter`

#### visitLiteralSuper

    public void visitLiteralSuper(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralSuper` in interface `Visitor`
Overrides:
  `visitLiteralSuper` in class `VisitorAdapter`

#### visitLiteralSwitch

    public void visitLiteralSwitch(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralSwitch` in interface `Visitor`
Overrides:
  `visitLiteralSwitch` in class `VisitorAdapter`

#### visitLiteralSynchronized

    public void visitLiteralSynchronized(GroovySourceAST t,
                                         int visit)

Specified by:
  `visitLiteralSynchronized` in interface `Visitor`
Overrides:
  `visitLiteralSynchronized` in class `VisitorAdapter`

#### visitLiteralThis

    public void visitLiteralThis(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralThis` in interface `Visitor`
Overrides:
  `visitLiteralThis` in class `VisitorAdapter`

#### visitLiteralThreadsafe

    public void visitLiteralThreadsafe(GroovySourceAST t,
                                       int visit)

Specified by:
  `visitLiteralThreadsafe` in interface `Visitor`
Overrides:
  `visitLiteralThreadsafe` in class `VisitorAdapter`

#### visitLiteralThrow

    public void visitLiteralThrow(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralThrow` in interface `Visitor`
Overrides:
  `visitLiteralThrow` in class `VisitorAdapter`

#### visitLiteralThrows

    public void visitLiteralThrows(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitLiteralThrows` in interface `Visitor`
Overrides:
  `visitLiteralThrows` in class `VisitorAdapter`

#### visitLiteralTransient

    public void visitLiteralTransient(GroovySourceAST t,
                                      int visit)

Specified by:
  `visitLiteralTransient` in interface `Visitor`
Overrides:
  `visitLiteralTransient` in class `VisitorAdapter`

#### visitLiteralTrue

    public void visitLiteralTrue(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralTrue` in interface `Visitor`
Overrides:
  `visitLiteralTrue` in class `VisitorAdapter`

#### visitLiteralTry

    public void visitLiteralTry(GroovySourceAST t,
                                int visit)

Specified by:
  `visitLiteralTry` in interface `Visitor`
Overrides:
  `visitLiteralTry` in class `VisitorAdapter`

#### visitLiteralVoid

    public void visitLiteralVoid(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitLiteralVoid` in interface `Visitor`
Overrides:
  `visitLiteralVoid` in class `VisitorAdapter`

#### visitLiteralVolatile

    public void visitLiteralVolatile(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitLiteralVolatile` in interface `Visitor`
Overrides:
  `visitLiteralVolatile` in class `VisitorAdapter`

#### visitLiteralWhile

    public void visitLiteralWhile(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitLiteralWhile` in interface `Visitor`
Overrides:
  `visitLiteralWhile` in class `VisitorAdapter`

#### visitLnot

    public void visitLnot(GroovySourceAST t,
                          int visit)

Specified by:
  `visitLnot` in interface `Visitor`
Overrides:
  `visitLnot` in class `VisitorAdapter`

#### visitLor

    public void visitLor(GroovySourceAST t,
                         int visit)

Specified by:
  `visitLor` in interface `Visitor`
Overrides:
  `visitLor` in class `VisitorAdapter`

#### visitLt

    public void visitLt(GroovySourceAST t,
                        int visit)

Specified by:
  `visitLt` in interface `Visitor`
Overrides:
  `visitLt` in class `VisitorAdapter`

#### visitMapConstructor

    public void visitMapConstructor(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitMapConstructor` in interface `Visitor`
Overrides:
  `visitMapConstructor` in class `VisitorAdapter`

#### visitMemberPointer

    public void visitMemberPointer(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitMemberPointer` in interface `Visitor`
Overrides:
  `visitMemberPointer` in class `VisitorAdapter`

#### visitMethodCall

    public void visitMethodCall(GroovySourceAST t,
                                int visit)

Specified by:
  `visitMethodCall` in interface `Visitor`
Overrides:
  `visitMethodCall` in class `VisitorAdapter`

#### visitMethodDef

    public void visitMethodDef(GroovySourceAST t,
                               int visit)

Specified by:
  `visitMethodDef` in interface `Visitor`
Overrides:
  `visitMethodDef` in class `VisitorAdapter`

#### visitMinus

    public void visitMinus(GroovySourceAST t,
                           int visit)

Specified by:
  `visitMinus` in interface `Visitor`
Overrides:
  `visitMinus` in class `VisitorAdapter`

#### visitMinusAssign

    public void visitMinusAssign(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitMinusAssign` in interface `Visitor`
Overrides:
  `visitMinusAssign` in class `VisitorAdapter`

#### visitMod

    public void visitMod(GroovySourceAST t,
                         int visit)

Specified by:
  `visitMod` in interface `Visitor`
Overrides:
  `visitMod` in class `VisitorAdapter`

#### visitModifiers

    public void visitModifiers(GroovySourceAST t,
                               int visit)

Specified by:
  `visitModifiers` in interface `Visitor`
Overrides:
  `visitModifiers` in class `VisitorAdapter`

#### visitModAssign

    public void visitModAssign(GroovySourceAST t,
                               int visit)

Specified by:
  `visitModAssign` in interface `Visitor`
Overrides:
  `visitModAssign` in class `VisitorAdapter`

#### visitMultiCatch

    public void visitMultiCatch(GroovySourceAST t,
                                int visit)

Specified by:
  `visitMultiCatch` in interface `Visitor`
Overrides:
  `visitMultiCatch` in class `VisitorAdapter`

#### visitMultiCatchTypes

    public void visitMultiCatchTypes(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitMultiCatchTypes` in interface `Visitor`
Overrides:
  `visitMultiCatchTypes` in class `VisitorAdapter`

#### visitNotEqual

    public void visitNotEqual(GroovySourceAST t,
                              int visit)

Specified by:
  `visitNotEqual` in interface `Visitor`
Overrides:
  `visitNotEqual` in class `VisitorAdapter`

#### visitNumBigDecimal

    public void visitNumBigDecimal(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitNumBigDecimal` in interface `Visitor`
Overrides:
  `visitNumBigDecimal` in class `VisitorAdapter`

#### visitNumBigInt

    public void visitNumBigInt(GroovySourceAST t,
                               int visit)

Specified by:
  `visitNumBigInt` in interface `Visitor`
Overrides:
  `visitNumBigInt` in class `VisitorAdapter`

#### visitNumDouble

    public void visitNumDouble(GroovySourceAST t,
                               int visit)

Specified by:
  `visitNumDouble` in interface `Visitor`
Overrides:
  `visitNumDouble` in class `VisitorAdapter`

#### visitNumInt

    public void visitNumInt(GroovySourceAST t,
                            int visit)

Specified by:
  `visitNumInt` in interface `Visitor`
Overrides:
  `visitNumInt` in class `VisitorAdapter`

#### visitNumFloat

    public void visitNumFloat(GroovySourceAST t,
                              int visit)

Specified by:
  `visitNumFloat` in interface `Visitor`
Overrides:
  `visitNumFloat` in class `VisitorAdapter`

#### visitNumLong

    public void visitNumLong(GroovySourceAST t,
                             int visit)

Specified by:
  `visitNumLong` in interface `Visitor`
Overrides:
  `visitNumLong` in class `VisitorAdapter`

#### visitObjblock

    public void visitObjblock(GroovySourceAST t,
                              int visit)

Specified by:
  `visitObjblock` in interface `Visitor`
Overrides:
  `visitObjblock` in class `VisitorAdapter`

#### visitOptionalDot

    public void visitOptionalDot(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitOptionalDot` in interface `Visitor`
Overrides:
  `visitOptionalDot` in class `VisitorAdapter`

#### visitPackageDef

    public void visitPackageDef(GroovySourceAST t,
                                int visit)

Specified by:
  `visitPackageDef` in interface `Visitor`
Overrides:
  `visitPackageDef` in class `VisitorAdapter`

#### visitParameterDef

    public void visitParameterDef(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitParameterDef` in interface `Visitor`
Overrides:
  `visitParameterDef` in class `VisitorAdapter`

#### visitParameters

    public void visitParameters(GroovySourceAST t,
                                int visit)

Specified by:
  `visitParameters` in interface `Visitor`
Overrides:
  `visitParameters` in class `VisitorAdapter`

#### visitPlus

    public void visitPlus(GroovySourceAST t,
                          int visit)

Specified by:
  `visitPlus` in interface `Visitor`
Overrides:
  `visitPlus` in class `VisitorAdapter`

#### visitPlusAssign

    public void visitPlusAssign(GroovySourceAST t,
                                int visit)

Specified by:
  `visitPlusAssign` in interface `Visitor`
Overrides:
  `visitPlusAssign` in class `VisitorAdapter`

#### visitPostDec

    public void visitPostDec(GroovySourceAST t,
                             int visit)

Specified by:
  `visitPostDec` in interface `Visitor`
Overrides:
  `visitPostDec` in class `VisitorAdapter`

#### visitPostInc

    public void visitPostInc(GroovySourceAST t,
                             int visit)

Specified by:
  `visitPostInc` in interface `Visitor`
Overrides:
  `visitPostInc` in class `VisitorAdapter`

#### visitQuestion

    public void visitQuestion(GroovySourceAST t,
                              int visit)

Specified by:
  `visitQuestion` in interface `Visitor`
Overrides:
  `visitQuestion` in class `VisitorAdapter`

#### visitRangeExclusive

    public void visitRangeExclusive(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitRangeExclusive` in interface `Visitor`
Overrides:
  `visitRangeExclusive` in class `VisitorAdapter`

#### visitRangeInclusive

    public void visitRangeInclusive(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitRangeInclusive` in interface `Visitor`
Overrides:
  `visitRangeInclusive` in class `VisitorAdapter`

#### visitRegexFind

    public void visitRegexFind(GroovySourceAST t,
                               int visit)

Specified by:
  `visitRegexFind` in interface `Visitor`
Overrides:
  `visitRegexFind` in class `VisitorAdapter`

#### visitRegexMatch

    public void visitRegexMatch(GroovySourceAST t,
                                int visit)

Specified by:
  `visitRegexMatch` in interface `Visitor`
Overrides:
  `visitRegexMatch` in class `VisitorAdapter`

#### visitSelectSlot

    public void visitSelectSlot(GroovySourceAST t,
                                int visit)

Specified by:
  `visitSelectSlot` in interface `Visitor`
Overrides:
  `visitSelectSlot` in class `VisitorAdapter`

#### visitSl

    public void visitSl(GroovySourceAST t,
                        int visit)

Specified by:
  `visitSl` in interface `Visitor`
Overrides:
  `visitSl` in class `VisitorAdapter`

#### visitSlAssign

    public void visitSlAssign(GroovySourceAST t,
                              int visit)

Specified by:
  `visitSlAssign` in interface `Visitor`
Overrides:
  `visitSlAssign` in class `VisitorAdapter`

#### visitSlist

    public void visitSlist(GroovySourceAST t,
                           int visit)

Specified by:
  `visitSlist` in interface `Visitor`
Overrides:
  `visitSlist` in class `VisitorAdapter`

#### visitSpreadArg

    public void visitSpreadArg(GroovySourceAST t,
                               int visit)

Specified by:
  `visitSpreadArg` in interface `Visitor`
Overrides:
  `visitSpreadArg` in class `VisitorAdapter`

#### visitSpreadDot

    public void visitSpreadDot(GroovySourceAST t,
                               int visit)

Specified by:
  `visitSpreadDot` in interface `Visitor`
Overrides:
  `visitSpreadDot` in class `VisitorAdapter`

#### visitSpreadMapArg

    public void visitSpreadMapArg(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitSpreadMapArg` in interface `Visitor`
Overrides:
  `visitSpreadMapArg` in class `VisitorAdapter`

#### visitSr

    public void visitSr(GroovySourceAST t,
                        int visit)

Specified by:
  `visitSr` in interface `Visitor`
Overrides:
  `visitSr` in class `VisitorAdapter`

#### visitSrAssign

    public void visitSrAssign(GroovySourceAST t,
                              int visit)

Specified by:
  `visitSrAssign` in interface `Visitor`
Overrides:
  `visitSrAssign` in class `VisitorAdapter`

#### visitStar

    public void visitStar(GroovySourceAST t,
                          int visit)

Specified by:
  `visitStar` in interface `Visitor`
Overrides:
  `visitStar` in class `VisitorAdapter`

#### visitStarAssign

    public void visitStarAssign(GroovySourceAST t,
                                int visit)

Specified by:
  `visitStarAssign` in interface `Visitor`
Overrides:
  `visitStarAssign` in class `VisitorAdapter`

#### visitStarStar

    public void visitStarStar(GroovySourceAST t,
                              int visit)

Specified by:
  `visitStarStar` in interface `Visitor`
Overrides:
  `visitStarStar` in class `VisitorAdapter`

#### visitStarStarAssign

    public void visitStarStarAssign(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitStarStarAssign` in interface `Visitor`
Overrides:
  `visitStarStarAssign` in class `VisitorAdapter`

#### visitStaticInit

    public void visitStaticInit(GroovySourceAST t,
                                int visit)

Specified by:
  `visitStaticInit` in interface `Visitor`
Overrides:
  `visitStaticInit` in class `VisitorAdapter`

#### visitStaticImport

    public void visitStaticImport(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitStaticImport` in interface `Visitor`
Overrides:
  `visitStaticImport` in class `VisitorAdapter`

#### visitStrictfp

    public void visitStrictfp(GroovySourceAST t,
                              int visit)

Specified by:
  `visitStrictfp` in interface `Visitor`
Overrides:
  `visitStrictfp` in class `VisitorAdapter`

#### visitStringConstructor

    public void visitStringConstructor(GroovySourceAST t,
                                       int visit)

Specified by:
  `visitStringConstructor` in interface `Visitor`
Overrides:
  `visitStringConstructor` in class `VisitorAdapter`

#### visitStringLiteral

    public void visitStringLiteral(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitStringLiteral` in interface `Visitor`
Overrides:
  `visitStringLiteral` in class `VisitorAdapter`

#### visitSuperCtorCall

    public void visitSuperCtorCall(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitSuperCtorCall` in interface `Visitor`
Overrides:
  `visitSuperCtorCall` in class `VisitorAdapter`

#### visitTraitDef

    public void visitTraitDef(GroovySourceAST t,
                              int visit)

Specified by:
  `visitTraitDef` in interface `Visitor`
Overrides:
  `visitTraitDef` in class `VisitorAdapter`

#### visitType

    public void visitType(GroovySourceAST t,
                          int visit)

Specified by:
  `visitType` in interface `Visitor`
Overrides:
  `visitType` in class `VisitorAdapter`

#### visitTypeArgument

    public void visitTypeArgument(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitTypeArgument` in interface `Visitor`
Overrides:
  `visitTypeArgument` in class `VisitorAdapter`

#### visitTypeArguments

    public void visitTypeArguments(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitTypeArguments` in interface `Visitor`
Overrides:
  `visitTypeArguments` in class `VisitorAdapter`

#### visitTypecast

    public void visitTypecast(GroovySourceAST t,
                              int visit)

Specified by:
  `visitTypecast` in interface `Visitor`
Overrides:
  `visitTypecast` in class `VisitorAdapter`

#### visitTypeLowerBounds

    public void visitTypeLowerBounds(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitTypeLowerBounds` in interface `Visitor`
Overrides:
  `visitTypeLowerBounds` in class `VisitorAdapter`

#### visitTypeParameter

    public void visitTypeParameter(GroovySourceAST t,
                                   int visit)

Specified by:
  `visitTypeParameter` in interface `Visitor`
Overrides:
  `visitTypeParameter` in class `VisitorAdapter`

#### visitTypeParameters

    public void visitTypeParameters(GroovySourceAST t,
                                    int visit)

Specified by:
  `visitTypeParameters` in interface `Visitor`
Overrides:
  `visitTypeParameters` in class `VisitorAdapter`

#### visitTypeUpperBounds

    public void visitTypeUpperBounds(GroovySourceAST t,
                                     int visit)

Specified by:
  `visitTypeUpperBounds` in interface `Visitor`
Overrides:
  `visitTypeUpperBounds` in class `VisitorAdapter`

#### visitUnaryMinus

    public void visitUnaryMinus(GroovySourceAST t,
                                int visit)

Specified by:
  `visitUnaryMinus` in interface `Visitor`
Overrides:
  `visitUnaryMinus` in class `VisitorAdapter`

#### visitUnaryPlus

    public void visitUnaryPlus(GroovySourceAST t,
                               int visit)

Specified by:
  `visitUnaryPlus` in interface `Visitor`
Overrides:
  `visitUnaryPlus` in class `VisitorAdapter`

#### visitVariableDef

    public void visitVariableDef(GroovySourceAST t,
                                 int visit)

Specified by:
  `visitVariableDef` in interface `Visitor`
Overrides:
  `visitVariableDef` in class `VisitorAdapter`

#### visitVariableParameterDef

    public void visitVariableParameterDef(GroovySourceAST t,
                                          int visit)

Specified by:
  `visitVariableParameterDef` in interface `Visitor`
Overrides:
  `visitVariableParameterDef` in class `VisitorAdapter`

#### visitWildcardType

    public void visitWildcardType(GroovySourceAST t,
                                  int visit)

Specified by:
  `visitWildcardType` in interface `Visitor`
Overrides:
  `visitWildcardType` in class `VisitorAdapter`

#### visitDefault

    public void visitDefault(GroovySourceAST t,
                             int visit)

Specified by:
  `visitDefault` in interface `Visitor`
Overrides:
  `visitDefault` in class `VisitorAdapter`

#### printUpdatingTabLevel

    protected void printUpdatingTabLevel(GroovySourceAST t,
                                         int visit,
                                         java.lang.String opening,
                                         java.lang.String subsequent,
                                         java.lang.String closing)

#### print

    protected void print(GroovySourceAST t,
                         int visit,
                         java.lang.String opening,
                         java.lang.String subsequent,
                         java.lang.String closing)

#### print

    protected void print(GroovySourceAST t,
                         int visit,
                         java.lang.String value)

#### printNewlineAndIndent

    protected void printNewlineAndIndent(GroovySourceAST t,
                                         int visit)

#### push

    public void push(GroovySourceAST t)

Specified by:
  `push` in interface `Visitor`
Overrides:
  `push` in class `VisitorAdapter`

#### pop

    public GroovySourceAST pop()

Specified by:
  `pop` in interface `Visitor`
Overrides:
  `pop` in class `VisitorAdapter`